unit MainInsert;

interface

uses
  System.SysUtils,System.StrUtils, System.Classes, JS, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs,WEBLib.REST, Vcl.Controls, Vcl.StdCtrls, WEBLib.StdCtrls, WEBLib.DropDown, Vcl.Menus, WEBLib.Menus,
  WEBLib.ComCtrls, WEBLib.JQCtrls, WEBLib.CDS, Data.DB, WEBLib.DB,WEBLib.WebTools, WEBLib.WebCtrls;

type
  TForm6 = class(TWebForm)
    CustomerName: TWebLabel;
    CustomerName2: TWebLabel;
    Attn: TWebLabel;
    CustomerAddress1: TWebLabel;
    CustomerAddress2: TWebLabel;
    City: TWebLabel;
    Province: TWebLabel;
    Country: TWebLabel;
    PostalCode: TWebLabel;
    PhoneNumber: TWebLabel;
    WebLabel1: TWebLabel;
    SaleRep: TWebLabel;
    FCS: TWebLabel;
    Currency: TWebLabel;
    Language: TWebLabel;
    Website: TWebLabel;
    Email: TWebLabel;
    EmailGen: TWebLabel;
    EmailStat: TWebLabel;
    Provenance: TWebLabel;
    Category: TWebLabel;
    Category2: TWebLabel;
    CustomerReference: TWebLabel;
    cu_name1: TWebEdit;
    cu_name2: TWebEdit;
    cu_attn: TWebEdit;
    cu_address1: TWebEdit;
    cu_address2: TWebEdit;
    cu_city: TWebEdit;
    cu_postalcode: TWebEdit;
    cu_phonenumber: TWebEdit;
    cu_faxnumber: TWebEdit;
    cu_fcs: TWebEdit;
    cu_country: TWebComboBox;
    cu_province: TWebComboBox;
    cu_salerep: TWebComboBox;
    cu_currency: TWebComboBox;
    btn_addcustomer: TWebButton;
    cu_language: TWebComboBox;
    cu_phonenumberext: TWebEdit;
    cu_website: TWebEdit;
    cu_email: TWebEdit;
    cu_emailgen: TWebEdit;
    cu_emailstat: TWebEdit;
    cu_provenance: TWebComboBox;
    cu_category: TWebComboBox;
    cu_category2: TWebComboBox;
    cu_ref: TWebComboBox;
    ConnectionGenSR: TWebClientConnection;
    GenSRDataset: TWebClientDataSet;
    ConnectionGenCurrencies: TWebClientConnection;
    GenCurrenciesDataset: TWebClientDataSet;
    ConnectionGenCountries: TWebClientConnection;
    GenCountriesDataset: TWebClientDataSet;
    ConnectionGenProvinces: TWebClientConnection;
    GenProvincesDataset: TWebClientDataSet;
    ConnectionGenLanguages: TWebClientConnection;
    GenLanguagesDataset: TWebClientDataSet;
    ConnectionMainFieldsPost: TWebClientConnection;
    ConnectionGenCustSource: TWebClientConnection;
    GenCustSource: TWebClientDataSet;
    ConnectionGenCat1: TWebClientConnection;
    GenCat1: TWebClientDataSet;
    ConnectionGenCat2: TWebClientConnection;
    GenCat2: TWebClientDataSet;
    procedure setGenSRParameters(Sender: TObject);
    procedure fillCountries(DataSet: TDataSet);
    procedure fillProvinces();
    procedure fillCurrencies(DataSet: TDataSet);
    procedure fillCustSource(DataSet: TDataSet);
    procedure switchEditModeFields(Sender: TObject);
    procedure fillLanguages(DataSet: TDataSet);
    procedure updateMainFields(Sender: TObject);
    procedure setGenCustSourceParameters(Sender: TObject);
    function FindFirstItem(InputString: string): string;
    [async] function fillDependentFields(): string;
    procedure fillCat(DataSet: TDataSet);
    procedure fillCat2(DataSet: TDataSet);
    procedure setGenCat2Parameters(Sender: TObject);
    procedure btn_addcustomerClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form6: TForm6;

implementation

{$R *.dfm}
function TForm6.FindFirstItem(InputString: string): string;
var
  OutputString: string;
  PositionOfEquals: Integer;
begin
// Find the position of the '=' character in the string
  PositionOfEquals := Pos('=', InputString);

  // Check if the '=' character was found
  if PositionOfEquals > 0 then
  begin
    // Extract the substring from the beginning up to (but not including) the '='
    OutputString := Copy(InputString, 1, PositionOfEquals - 1);
  end
  else
  begin
    // If '=' is not found, handle accordingly (e.g., use the whole string or clear OutputString)
    OutputString := InputString; // Or OutputString := ''; depending on requirements
  end;
  Result:= OutputString;
end;

procedure TForm6.btn_addcustomerClick(Sender: TObject);
begin
      WriteLn('ok');
end;

procedure TForm6.fillCat(DataSet: TDataSet);
begin
GenCat1.First;
while not GenCat1.Eof do
  begin
    cu_category.Items.AddPair(GenCat1.FieldByName('CU090IDNO').AsString,GenCat1.FieldByName('CU090DESC').AsString);
    GenCat1.Next;
  end;
     ConnectionGenCat2.Active := true;
end;

procedure TForm6.fillCat2(DataSet: TDataSet);
begin
GenCat2.First;
while not GenCat2.Eof do
  begin
    cu_category.Items.AddPair(GenCat2.FieldByName('CU090IDNO').AsString,GenCat2.FieldByName('CU090DESC').AsString);
    GenCat1.Next;
  end;
end;
procedure TForm6.fillCountries(DataSet: TDataSet);
begin
GenCountriesDataset.Open;
GenCountriesDataset.First;
  while not GenCountriesDataset.Eof do
  begin
    cu_country.Items.AddPair(GenCountriesDataset.FieldByName('PV005COUNT').AsString,GenCountriesDataset.FieldByName('PV005DESC').AsString);
    GenCountriesDataset.Next;
  end;
   fillProvinces();
end;
procedure TForm6.fillProvinces();
begin
ConnectionGenProvinces.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenProvinces?pv001count=%s', [FindFirstItem(cu_country.Text)]);
ConnectionGenProvinces.Active := true;
 while not GenProvincesDataset.Eof do
  begin
    cu_province.Items.AddPair(GenProvincesDataset.FieldByName('PV001PROV').AsString,GenProvincesDataset.FieldByName('PV001DESC').AsString);
    GenProvincesDataset.Next;
  end;
end;
procedure TForm6.fillCurrencies(DataSet: TDataSet);
begin
GenCurrenciesDataset.Open;
GenCurrenciesDataset.First;
  while not GenCurrenciesDataset.Eof do
  begin
    cu_currency.Items.AddPair(GenCurrenciesDataset.FieldByName('CO040CODE').AsString,GenCurrenciesDataset.FieldByName('CO040DESC').AsString);
    GenCurrenciesDataset.Next;
  end;
end;

procedure TForm6.fillLanguages(DataSet: TDataSet);
begin
 WriteLn('Entered 1');
 GenLanguagesDataset.First;
  while not GenLanguagesDataset.Eof do
  begin
    cu_language.Items.AddPair(GenLanguagesDataset.FieldByName('CO090LANG').AsString,GenLanguagesDataset.FieldByName('CO090DESC').AsString);
    GenLanguagesDataset.Next;
  end;
  end;

procedure TForm6.fillCustSource(DataSet: TDataSet) ;
begin
GenCustSource.First;
  while not GenCustSource.Eof do
  begin
    cu_provenance.Items.AddPair(GenCustSource.FieldByName('CU080IDNO').AsString,GenCustSource.FieldByName('CU080DESC').AsString);
    GenCustSource.Next;
  end;
  if Assigned(GenCustSource.FindField('FSaleRep')) then
  begin
  cu_provenance.ItemIndex:= cu_provenance.Items.IndexOfName(GenCustSource.FieldByName('FSaleRep').AsString);
  end;
end;

function TForm6.fillDependentFields():string;
begin
 ConnectionGenLanguages.Active := True;
 ConnectionGenCurrencies.Active := True;
 ConnectionGenCountries.Active := True;
 ConnectionGenCustSource.Active := true;
 Result:= 'ok';
end;

procedure TForm6.setGenCat2Parameters(Sender: TObject);
begin
ConnectionGenCat2.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenCat2?cu090idno=%s',[FindFirstItem(cu_category.Text)]);
end;

procedure TForm6.setGenCustSourceParameters(Sender: TObject);
begin
WriteLn(cu_language.Text);
ConnectionGenCustSource.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenCustSource?co090lang=%s',[FindFirstItem(cu_language.Text)]);
end;

procedure TForm6.setGenSRParameters(Sender: TObject);
var param1: string;
begin
  param1 := GetQueryParam('co001comp');
  if param1 = '' then
  //Envoyer user a la page precedente car aucun parametre fournis
  else
  ConnectionGenSR.URI := Format('http://localhost:2001/tms/xdata/CrmService/GetGenSR?co001comp=%s', [param1]);
end;

procedure TForm6.switchEditModeFields(Sender: TObject);
var areFieldsEnabled: boolean;
begin
if cu_name1.enabled then
areFieldsEnabled := true
else
areFieldsEnabled := false;
 cu_country.Enabled	:= not areFieldsEnabled;
 cu_province.Enabled := not areFieldsEnabled;
 cu_salerep.Enabled:= not areFieldsEnabled;
 cu_currency.Enabled := not areFieldsEnabled;
 cu_name1.Enabled	:= not areFieldsEnabled;
 cu_name2.Enabled	:= not areFieldsEnabled;
 cu_attn.Enabled	:= not areFieldsEnabled;
 cu_address1.Enabled	:= not areFieldsEnabled;
 cu_address2.Enabled	:= not areFieldsEnabled;
 cu_city.Enabled	:= not areFieldsEnabled;
 cu_postalcode.Enabled	:= not areFieldsEnabled;
 cu_phonenumber.Enabled	:= not areFieldsEnabled;
 cu_faxnumber.Enabled	:= not areFieldsEnabled;
 cu_fcs.Enabled	:= not areFieldsEnabled;
 cu_language.Enabled	:= not areFieldsEnabled;
 cu_website.Enabled	:= not areFieldsEnabled;
 cu_email.Enabled	:= not areFieldsEnabled;
 cu_emailgen.Enabled	:= not areFieldsEnabled;
 cu_emailstat.Enabled	:= not areFieldsEnabled;
 cu_provenance.Enabled	:= not areFieldsEnabled;
 cu_category.Enabled	:= not areFieldsEnabled;
 cu_category2.Enabled	:= not areFieldsEnabled;
end;

procedure TForm6.updateMainFields(Sender: TObject);
var co001comp: string;
begin
Writeln('Set params');
co001comp := GetQueryParam('co001comp');
ConnectionMainFieldsPost.URI := Format(
    'http://localhost:2001/tms/xdata/CrmService/PostMainFields?insert_update=%s&co001comp=%s&' +
    'sl001idno=%s&cu001csuser=%s&cu001lang=%s&cu080idno=%s&cu090idno=%s&cu095idno=%s&' +
    'cu001name=%s&cu001name2=%s&cu001ref1=%s&cu001email=%s&cu001emailstat=%s&' +
    'cu001emailgen=%s&cu001attn=%s&cu001adr1=%s&cu001adr2=%s&cu001web=%s&' +
    'cu001city=%s&pv001prov=%s&co040code=%s&pv005count=%s&cu001cdpl=%s&' +
    'cu001teln=%s&cu001telext=%s&cu001fax=%s',
    [
        'I',
        co001comp,
        IfThen(cu_salerep.Text <> '', cu_salerep.Text, ''),
        IfThen(cu_fcs.Text <> '', cu_fcs.Text, ''),
        IfThen(cu_language.Text <> '', FindFirstItem(cu_language.Text), ''),
        IfThen(cu_provenance.Text <> '', FindFirstItem(cu_provenance.Text), ''),
        IfThen(cu_category.Text <> '', FindFirstItem(cu_category.Text), ''),
        IfThen(cu_category2.Text <> '', FindFirstItem(cu_category2.Text), ''),
        IfThen(cu_name1.Text <> '', cu_name1.Text, ''),
        IfThen(cu_name2.Text <> '', cu_name2.Text, ''),
        IfThen(cu_ref.Text <> '', cu_ref.Text, ''),
        IfThen(cu_email.Text <> '', cu_email.Text, ''),
        IfThen(cu_emailstat.Text <> '', cu_emailstat.Text, ''),
        IfThen(cu_emailgen.Text <> '', cu_emailgen.Text, ''),
        IfThen(cu_attn.Text <> '', cu_attn.Text, ''),
        IfThen(cu_address1.Text <> '', cu_address1.Text, ''),
        IfThen(cu_address2.Text <> '', cu_address2.Text, ''),
        IfThen(cu_website.Text <> '', cu_website.Text, ''),
        IfThen(cu_city.Text <> '', cu_city.Text, ''),
        IfThen(cu_province.Text <> '', FindFirstItem(cu_province.Text), ''),
        IfThen(cu_currency.Text <> '', FindFirstItem(cu_currency.Text), ''),
        IfThen(cu_country.Text <> '', FindFirstItem(cu_country.Text), ''),
        IfThen(cu_postalcode.Text <> '', cu_postalcode.Text, ''),
        IfThen(cu_phonenumber.Text <> '', cu_phonenumber.Text, ''),
        IfThen(cu_phonenumberext.Text <> '', cu_phonenumberext.Text, ''),
        IfThen(cu_faxnumber.Text <> '', cu_faxnumber.Text, '')
    ]
);

  Writeln(ConnectionMainFieldsPost.URI);
 ConnectionMainFieldsPost.Active := true;
end;
end.
